# Notepad App Module for NVDA
# Behringer X-Touch Editor for Compact and Mini
# Preset loading gestures only.
# www.azslow.com, 2017
#

import appModuleHandler
import ui
import versionInfo
import winUser
import mouseHandler
import api

class AppModule(appModuleHandler.AppModule):

	def __appPosition(self):
		obj = api.getFocusObject()
		return obj.location

	def __clickOnPosition(self, dX, dY):
		(x, y, w, h) = self.__appPosition()
		x = x + dX
		y = y + dY
		winUser.setCursorPos(x,y)
		winUser.mouse_event(winUser.MOUSEEVENTF_LEFTDOWN,x,y,None,None)
		winUser.mouse_event(winUser.MOUSEEVENTF_LEFTUP,x,y,None,None)

	def script_loadPreset(self, gesture):
		self.__clickOnPosition(75, 140)
	script_loadPreset.__doc__ = _("Load preset from file. Press enter in the confirmation dialog.")

	def script_dumpToA(self, gesture):
		self.__clickOnPosition(420, 140)
	script_dumpToA.__doc__ = _("Upload current preset to the layer A. Press enter in the confirmation dialog.")

	def script_dumpToB(self, gesture):
		self.__clickOnPosition(500, 140)
	script_dumpToB.__doc__ = _("Upload current preset to the layer B. Press enter in the confirmation dialog.")

	def script_modeMIDI(self, gesture):
		self.__clickOnPosition(90, 270)
	script_modeMIDI.__doc__ = _("Switch X-Touch into MIDI mode.")

	def script_modeMackie(self, gesture):
		self.__clickOnPosition(160, 270)
	script_modeMackie.__doc__ = _("Switch X-Touch into Mackie mode.")

	__gestures = {
		"kb:NVDA+shift+l": "loadPreset",
		"kb:NVDA+shift+a": "dumpToA",
		"kb:NVDA+shift+b": "dumpToB",
		"kb:NVDA+shift+m": "modeMIDI",
		"kb:NVDA+shift+n": "modeMackie",
	}
